Index: Connection.cpp
===================================================================
RCS file: Connection.cpp
diff -N Connection.cpp
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Connection.cpp	10 Apr 2005 22:43:19 -0000
@@ -0,0 +1,185 @@
+//////////////////////////////////////////////////////////////////////////
+// $Id: Connection.cpp,v 1.13 2005/04/10 22:03:08 klas Exp $
+//
+// Usage: Data class. inherited from Connection, everything pertaining to
+//        data connection goes here.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+//////////////////////////////////////////////////////////////////////////
+
+#define CONNECTION_CPP
+#define NETINCLS
+
+#include "Connection.h"
+
+Connection::Connection()
+{
+  sem_init(&this->lock, 0, 1);
+  this->_settings.reset();
+  this->_packet_size = READ_SIZE;
+}
+
+Connection::~Connection()
+{
+  if(this->_socket_id)
+    close(this->_socket_id);
+
+  sem_destroy(&this->lock);
+
+#ifdef USE_TLS
+  // TLS cleanup here.
+  if(this->settings(TLS_INITED))
+  {
+    gnutls_db_remove_session(this->session);
+    gnutls_deinit(this->session);
+  }
+#endif
+  if(this->thread_id())
+  {
+    sem_wait(&cleanup_list_lock);
+    cleanup_list.push_back(this->thread_id());
+    sem_post(&cleanup_list_lock);
+  }
+}
+
+ssize_t Connection::send(const char *message, size_t len)
+{
+  assert(len <= this->_packet_size && len > 0);
+  ssize_t ret = -1;
+
+  sem_wait(&this->lock);
+#ifdef USE_TLS
+  if(this->settings(TLS_ENABLED))
+  {
+    ret = gnutls_record_send(this->session, message, len);
+    if(ret == GNUTLS_E_AGAIN || ret == GNUTLS_E_INTERRUPTED)
+      ret = gnutls_record_send(this->session, message, len);
+  }
+  else
+#endif // USE_TLS
+    ret = write(this->_socket_id, message, len);
+
+  sem_post(&this->lock);
+  if(ret < 0)
+    logging->log_this(3, TYPE_INFO, "write to socket " +
+        util.itos(this->socket_id()) + " failed: %m");
+
+  return ret;
+}
+
+ssize_t Connection::receive(char *message, size_t len)
+{
+  assert(len <= this->_packet_size && len > 0);
+  ssize_t ret = -1;
+
+#ifdef USE_TLS
+  if(this->settings(TLS_ENABLED))
+    ret = gnutls_record_recv(this->session, message, len);
+  else
+#endif
+    ret = read(this->socket_id(), message, len);
+
+  return ret;
+}
+
+Connection &Connection::operator<<(long long int num)
+{
+  return (*this << util.itos(num));
+}
+
+Connection &Connection::operator<<(string message)
+{
+  if(this->send(message.c_str(), message.size()) < 0)
+  this->settings(FAILURE, B_SET);
+  return *this;
+}
+
+#ifdef USE_TLS
+bool Connection::engage_tls(void)
+{
+  bool ret = false;
+  gnutls_init(&session, GNUTLS_SERVER);
+
+  gnutls_set_default_priority(this->session);
+
+  gnutls_credentials_set(this->session, GNUTLS_CRD_CERTIFICATE, x509_cred);
+
+  gnutls_certificate_server_set_request(this->session, GNUTLS_CERT_REQUEST);
+
+  gnutls_dh_set_prime_bits(this->session, 1024);
+
+  // these are for the connection cache
+  gnutls_db_set_retrieve_function(this->session, tls_db_fetch);
+  gnutls_db_set_remove_function(this->session, tls_db_delete);
+  gnutls_db_set_store_function(this->session, tls_db_store);
+  gnutls_db_set_ptr(this->session, NULL);
+
+  // associating the session with the socket.
+  gnutls_transport_set_ptr(this->session,
+      reinterpret_cast<gnutls_transport_ptr>(this->socket_id()));
+  this->settings(TLS_INITED, B_SET);
+
+  if(gnutls_handshake(this->session) >= 0)
+  {
+    this->settings(TLS_ENABLED, B_SET);
+    this->packet_size(gnutls_record_get_max_size(this->session));
+    ret = true;
+  }
+
+  return ret;
+}
+
+bool Connection::disengage_tls(void)
+{
+  gnutls_bye(this->session, GNUTLS_SHUT_RDWR);
+  this->settings(TLS_ENABLED, B_RESET);
+  return true;
+}
+
+bool Connection::verify_cert(void)
+{
+  bool ret = false;
+  if (gnutls_certificate_type_get(this->session) == GNUTLS_CRT_X509)
+  {
+    int verified = gnutls_certificate_verify_peers(this->session);
+    if(util.is_set(verified, GNUTLS_CERT_REVOKED))
+      logging->log_this(2, TYPE_AUTH, this->user_name() +
+          + " tried to login with a revoked certificate.");
+    else if(!util.is_set(verified, GNUTLS_CERT_INVALID) &&
+        !util.is_set(verified, GNUTLS_CERT_SIGNER_NOT_FOUND))
+    {
+      size_t cert_list_size = 0;
+      // I really hope gnutls has their locking code in shape. get_peers just
+      // gives us some memory.. *shudder*                     
+      const gnutls_datum *cert_list = gnutls_certificate_get_peers(
+          this->session, &cert_list_size);
+      if(cert_list_size > 0)
+      {
+        gnutls_x509_crt peer_cert;
+        gnutls_x509_crt_init(&peer_cert);
+        gnutls_x509_crt_import(peer_cert, &cert_list[0], GNUTLS_X509_FMT_DER);
+        char dn_buf[200] = {0}, ca_buf[200] = {0};
+        size_t buf_size = 199, ca_size = 199;
+        gnutls_x509_crt_get_dn(peer_cert, dn_buf, &buf_size);
+        gnutls_x509_crt_get_issuer_dn(peer_cert, ca_buf, &ca_size);
+        if(buf_size > 0 && ca_size > 0)
+        {
+          // here we call an external program to ask if this user may login
+          // with this cert.
+          //  format is "<user> <host/ip> <ca-dn> <cert-dn>"
+          string call = config->general.verify_client + " " +
+            this->user_name() + " " + this->host_name() +
+            " \"" + ca_buf + "\" \"" + dn_buf + "\"";
+          logging->log_this(5, TYPE_DEBUG, "running:" + call);
+          int approved = system(call.c_str());
+          if(WEXITSTATUS(approved) == 0)
+            ret = true;
+        }
+        gnutls_x509_crt_deinit(peer_cert);
+      }
+    }
+  }
+  return ret;
+}
+#endif // USE_TLS
Index: Connection.h
===================================================================
RCS file: Connection.h
diff -N Connection.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Connection.h	10 Apr 2005 22:43:19 -0000
@@ -0,0 +1,130 @@
+//////////////////////////////////////////////////////////////////////////
+// $Id: Connection.h,v 1.10 2005/04/10 21:00:45 klas Exp $
+//
+// Usage: Connection class. is inherited to user and data.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+//////////////////////////////////////////////////////////////////////////
+
+#ifndef CONNECTION_H
+#define CONNECTION_H
+
+#ifdef CONNECTION_CPP
+#include "generic.h"
+#include "Utilities.h"
+#include "Configuration.h"
+#include "Log.h"
+#endif // CONNECTION_CPP
+
+const int B_SET = 1;
+const int B_RESET = 2;
+const int B_FLIP = 3;
+
+const int FACT_TYPE = 0; // for mlsx
+const int FACT_SIZE = 1;
+const int FACT_MODIFY = 2;
+const int FACT_UNIQUE = 3;
+const int FACT_U_MODE = 4;
+const int FACT_U_UID = 5;
+const int FACT_U_GID = 6;
+const int FACT_U_LINK = 7;
+const int FACT_PERM = 8;
+const int LAST_FACT = 8;
+
+const int DATA_ACCT = 9;
+const int BINARY = 10;
+const int COMPRESSED = 11;
+const int PASSIVE = 12;
+const int ANONYMOUS = 13;
+const int DATA_OPEN = 14;
+const int EPSV_ONLY = 15;
+const int RETR_TRANS = 16;
+const int PAM_DONE = 17;
+const int FAILURE = 18;
+#ifdef USE_TLS
+const int TLS_ENABLED = 19;
+const int TLS_INITED = 20;
+const int TLS_PBSZ = 21;
+const int TLS_PROT_D = 22;
+
+// keep an eye on these.. different depending on TLS or not...
+const int TOTAL_U_BIT = 23;
+#else
+const int TOTAL_U_BIT = 19;
+#endif // USE_TLS
+
+// macro that builds get and set functions for us.
+#define MEMBER(func, type, var)  private: type var; \
+  public: type func(void)const{return var;} \
+  public: void func(type var){ \
+          sem_wait(&this->lock); \
+          this->var = var; \
+          sem_post(&this->lock); \
+        }
+
+class Connection
+{
+  public:
+    sem_t lock;
+    ssize_t send(const char*, size_t);
+    ssize_t receive(char*, size_t);
+    Connection &operator<<(long long int num);
+    Connection &operator<<(string message);
+#ifdef USE_TLS
+    bool engage_tls();
+    bool disengage_tls();
+    bool verify_cert();
+#endif // USE_TLS
+    bitset<TOTAL_U_BIT> settings() const
+    {
+      return _settings;
+    }
+    bool settings(int bit) const
+    {
+      assert(bit < TOTAL_U_BIT);
+      return(this->_settings.test(bit));
+    }
+    void settings(int bit, int way)
+    {
+      assert(way < 4 && way > 0);
+      sem_wait(&this->lock);
+      if(way == B_SET)
+        this->_settings.set(bit);
+      else if(way == B_RESET)
+        this->_settings.reset(bit);
+      else if(way == B_FLIP)
+        this->_settings.flip(bit);
+      sem_post(&this->lock);
+    }
+  protected:
+    Connection();
+    ~Connection();
+    bitset<TOTAL_U_BIT> _settings;
+    MEMBER(thread_id, pthread_t, _thread_id);
+    MEMBER(host_name, string, _host_name);
+    MEMBER(socket_id, int, _socket_id);
+    MEMBER(addr, struct sockaddr_in, _addr);
+    MEMBER(packet_size, size_t, _packet_size);
+    MEMBER(timeout, struct timeval, _timeout);
+    MEMBER(user_name, string, _user_name);
+  private:
+#ifdef USE_TLS
+    gnutls_session session;
+#endif // USE_TLS
+};
+
+#undef MEMBER
+
+const int READ_SIZE = 16384;
+
+extern vector<pthread_t> cleanup_list;
+extern sem_t cleanup_list_lock;
+#ifdef USE_TLS
+extern gnutls_certificate_credentials x509_cred;
+extern int tls_db_store(void*, gnutls_datum, gnutls_datum);
+extern gnutls_datum tls_db_fetch(void*, gnutls_datum);
+extern int tls_db_delete(void*, gnutls_datum);
+#endif // USE_TLS
+
+#endif // CONNECTION_H
Index: Data.cpp
===================================================================
RCS file: Data.cpp
diff -N Data.cpp
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Data.cpp	10 Apr 2005 22:43:19 -0000
@@ -0,0 +1,158 @@
+//////////////////////////////////////////////////////////////////////////
+// $Id: Data.cpp,v 1.6 2005/04/02 12:15:21 klas Exp $
+//
+// Usage: Data class. inherited from Connection, everything pertaining to
+//        data connection goes here.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+//////////////////////////////////////////////////////////////////////////
+
+#define DATA_CPP
+#define NETINCLS
+
+#include "Data.h"
+
+Data::Data(User *user, int file_id, string file_name, int trans_type)
+  : Connection()
+{
+  this->thread_id(0); // data_wrapper sets this to it's own.
+  this->_file_id = file_id;
+  this->_file_name = file_name;
+  this->user = user;
+  this->_settings = user->settings();
+  this->addr(user->data_addr());
+  struct timeval tv = {1, 0};
+  this->timeout(tv);
+  if(trans_type == 1)
+    this->settings(RETR_TRANS, B_SET);
+
+  this->settings(DATA_OPEN, B_SET);
+#ifdef USE_TLS
+  this->settings(TLS_INITED, B_RESET);
+  this->settings(TLS_ENABLED, B_RESET);
+#endif // USE_TLS
+
+  if(this->settings(PASSIVE))
+    this->open_passive();
+  else // ACTIVE
+    this->open_active();
+
+  // if the data connection comes from another host than the
+  // ctrl connection we drop it.. unless the user is tls protected.
+  if(this->addr().sin_addr.s_addr != user->addr().sin_addr.s_addr)
+  {
+#ifdef USE_TLS
+    if(!user->settings(TLS_ENABLED))
+    {
+#endif // USE_TLS
+      close(this->socket_id());
+      this->settings(DATA_OPEN, B_RESET);
+    }
+#ifdef USE_TLS
+  }
+#endif //USE_TLS
+}
+
+void Data::open_passive()
+{
+  socklen_t len = sizeof(this->addr());
+  struct sockaddr_in temp_addr = this->addr();
+
+  fd_set acc_set;
+  FD_ZERO(&acc_set);
+  FD_SET(user->data_id(), &acc_set);
+  struct timeval tv = this->timeout();
+
+  if(select(user->data_id() + 1, &acc_set, NULL, NULL, &tv) > 0)
+  {
+    int ret = accept(user->data_id(),
+        reinterpret_cast<struct sockaddr*>(&temp_addr), &len);
+    this->socket_id(ret);
+    this->addr(temp_addr);
+  }
+  else
+    this->settings(DATA_OPEN, B_RESET);
+
+  close(user->data_id());
+}
+
+void Data::open_active()
+{
+  this->socket_id(socket(AF_INET, SOCK_STREAM, IPPROTO_TCP));
+
+  int on = 1;
+  setsockopt(this->socket_id(), SOL_SOCKET, SO_REUSEADDR,
+      (static_cast<void*>(&on)), sizeof(on));
+  struct sockaddr_in my_addr;
+  my_addr.sin_port = htons(config->general.data_port);
+  my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
+
+  uid_t old_uid = 0;
+  // if dataport is below 1024 we need root.
+  if(config->general.data_port <= 1024)
+  {
+    old_uid = geteuid();
+    seteuid(0);
+  }
+  int ret = bind(this->socket_id(), reinterpret_cast<struct sockaddr*>
+      (&my_addr), sizeof(my_addr));
+  if(config->general.data_port <= 1024)
+    seteuid(old_uid);
+
+  if(ret != 0)
+    logging->log_this(3, LOG_INFO,
+        "Failed to bind to data port " + util.itos(config->general.data_port)
+        + ", falling back to arbitrary port.");
+
+  struct sockaddr_in tmp_addr = this->addr();
+
+  // go into nonblocking
+  long sock_arg = fcntl(this->socket_id(), F_GETFL, NULL);
+  sock_arg |= O_NONBLOCK;
+  fcntl(this->socket_id(), F_SETFL, sock_arg);
+
+  int sock_err = connect(this->socket_id(), reinterpret_cast<struct sockaddr*>
+        (&tmp_addr), sizeof(tmp_addr));
+  this->addr(tmp_addr);
+
+  if(sock_err < 0)
+    if(errno == EINPROGRESS)
+    {
+      struct timeval tv = this->timeout();
+      fd_set con_set;
+      FD_ZERO(&con_set);
+      FD_SET(this->socket_id(), &con_set);
+      if(select(this->socket_id() + 1, NULL, &con_set, NULL, &tv) < 0)
+        this->settings(DATA_OPEN, B_RESET);
+    }
+    else
+      this->settings(DATA_OPEN, B_RESET);
+
+  // leave non blocking
+  long sock_arg2 = fcntl(this->socket_id(), F_GETFL, NULL);
+  sock_arg2 &= (~O_NONBLOCK);
+  fcntl(this->socket_id(), F_SETFL, sock_arg2);
+}
+
+Data::~Data()
+{
+  if(this->_file_id)
+    close(this->_file_id);
+
+  if(this->thread_id())
+  {
+    sem_wait(&user->lock);
+    user->data_vec.erase(user->get_data_it(this->thread_id()));
+    sem_post(&user->lock);
+    logging->log_this(4, TYPE_INFO, "data thread " +
+        util.itos(this->thread_id()) +
+        " exiting. Remaining data connections for " + user->user_name() +
+        " is: " + util.itos(user->data_vec.size()));
+  }
+}
+
+void kill_data(void *data)
+{
+  delete static_cast<Data*>(data);
+}
Index: Data.h
===================================================================
RCS file: Data.h
diff -N Data.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Data.h	10 Apr 2005 22:43:19 -0000
@@ -0,0 +1,55 @@
+//////////////////////////////////////////////////////////////////////////
+// $Id: Data.h,v 1.6 2005/03/29 20:13:57 klas Exp $
+//
+// Usage: Data class. inherited from Connection, everything pertaining to
+//        data connection goes here.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+//////////////////////////////////////////////////////////////////////////
+
+#ifndef DATA_H
+#define DATA_H
+
+#ifdef DATA_CPP
+#include "generic.h"
+#include "Utilities.h"
+#include "Configuration.h"
+#include "Log.h"
+#include "Connection.h"
+#include "User.h"
+#endif // DATA_CPP
+
+// macro that builds get and set functions for us.
+#define MEMBER(func, type, var)  private: type var; \
+  public: type func(void)const{return var;} \
+  public: void func(type var){ \
+          sem_wait(&this->lock); \
+          this->var = var; \
+          sem_post(&this->lock); \
+        }
+
+class Data : public Connection
+{
+  friend class User;
+  friend void *data_wrapper(void*);
+  private:
+    User *user;
+    void open_active();
+    void open_passive();
+  public:
+    Data(User *user, int file_id = -1, string file_name = "",
+        int trans_type = 0);
+    ~Data();
+    MEMBER(trans_type, int, _trans_type);
+    MEMBER(file_id, int, _file_id);
+    MEMBER(file_name, string, _file_name);
+};
+
+#undef MEMBER
+
+void kill_data(void*);
+
+extern pthread_key_t my_data;
+
+#endif // DATA_H
Index: Handler.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Handler.cpp,v
retrieving revision 1.143
diff -u -p -b -r1.143 Handler.cpp
--- Handler.cpp	22 Jan 2005 17:18:51 -0000	1.143
+++ Handler.cpp	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: Handler.cpp,v 1.143 2005/01/22 17:18:51 klas Exp $
+// $Id: Handler.cpp,v 1.157 2005/04/10 21:57:36 jockelundin Exp $
 //
 // Usage: the main loop for connected clients and interpreter for
 //        ftp commands.
@@ -8,67 +8,82 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __HANDLER_CPP__
-#define __NETINCLS__
+#define HANDLER_CPP
+#define NETINCLS
 #include "Handler.h"
 #include "commands.hlp"
 
-struct command_info Handler::cmd_info[] = {
-  { "SYST",  0, &Commands::sim1, COM_SYST,  HLP_SYST }, //0
-  { "HELP", -1, &Commands::help, BEFORE_USER, HLP_HELP },
-  { "RETR", -1, &Commands::retr, 0,         HLP_RETR },
-  { "STOR", -1, &Commands::stor, COM_STOR,  HLP_STOR },
-  { "PORT",  1, &Commands::port, COM_PORT,  HLP_PORT },
-  { "EPRT",  1, &Commands::port, COM_EPRT,  HLP_EPRT }, //5
-  { "PASV",  0, &Commands::pasv, COM_PASV,  HLP_PASV },
-  { "EPSV", -1, &Commands::pasv, COM_EPSV,  HLP_EPSV },
-  { "PWD",   0, &Commands::sim1, COM_PWD,   HLP_PWD  },
-  { "CWD",  -1, &Commands::cwd,  COM_CWD,   HLP_CWD  },
-  { "CDUP",  0, &Commands::cwd,  COM_CDUP,  HLP_CDUP }, //10
-  { "MKD",  -1, &Commands::mkd,  0,         HLP_MKD  },
-  { "RMD",  -1, &Commands::rmd,  0,         HLP_RMD  },
-  { "DELE", -1, &Commands::dele, 0,         HLP_DELE },
-  { "LIST", -1, &Commands::list, COM_LONG,  HLP_LIST },
-  { "NLST", -1, &Commands::list, COM_SHORT, HLP_NLST }, //15
-  { "TYPE", -1, &Commands::sim1, COM_TYPE,  HLP_TYPE },
-  { "MODE",  1, &Commands::sim1, COM_MODE,  HLP_MODE },
-  { "STRU",  1, &Commands::sim1, COM_STRU,  HLP_STRU },
-  { "SIZE", -1, &Commands::sim2, COM_SIZE,  HLP_SIZE },
-  { "USER",  1, &Commands::user, BEFORE_USER, HLP_USER }, //20
-  { "PASS",  1, &Commands::pass, BEFORE_USER, HLP_PASS },
-  { "QUIT", -1, &Commands::quit, BEFORE_USER, HLP_QUIT },
-  { "NOOP",  0, &Commands::sim1, COM_NOOP,  HLP_NOOP },
-  { "MDTM", -1, &Commands::sim2, COM_MDTM,  HLP_MDTM },
-  { "FEAT",  0, &Commands::sim1, COM_FEAT | BEFORE_USER, HLP_FEAT }, //25
-  { "RNFR", -1, &Commands::rname, COM_FROM, HLP_RNFR },
-  { "RNTO", -1, &Commands::rname, COM_TO,   HLP_RNTO },
-  { "MLST", -1, &Commands::sim2, COM_MLST,  HLP_MLST },
-  { "MLSD", -1, &Commands::list, COM_MLSD,  HLP_MLSD },
-  { "APPE", -1, &Commands::stor, COM_APPE,  HLP_APPE }, //30
-  { "OPTS", -1, &Commands::opts, 0,         HLP_OPTS },
-  { "REST",  1, &Commands::rest, 0,         HLP_REST },
-  { "XCWD", -1, &Commands::cwd,  COM_CWD,   HLP_CWD  }, // as of rfc 1123
-  { "XPWD",  0, &Commands::sim1, COM_PWD,   HLP_PWD  },
-  { "XCUP",  0, &Commands::sim1, COM_CDUP,  HLP_CDUP }, //35
-  { "XMKD", -1, &Commands::mkd,  0,         HLP_MKD  },
-  { "XRMD", -1, &Commands::rmd,  0,         HLP_RMD  },
+class Handler *handler;
+
+Handler::Handler()
+{
+  // first argument is number of arguments to the command, they should
+  //  be self explaining except the negative ones. -1 means any number,
+  //  -2 means anything but 0.
+  cmd_info["SYST"] = command_info(0, &Commands::sim1, COM_SYST, HLP_SYST);
+  cmd_info["HELP"] = command_info(-1, &Commands::help, BEFORE_USER, HLP_HELP);
+  cmd_info["RETR"] = command_info(-2, &Commands::retr, 0, HLP_RETR);
+  cmd_info["STOR"] = command_info(-2, &Commands::stor, COM_STOR, HLP_STOR);
+  cmd_info["PORT"] = command_info(1, &Commands::port, COM_PORT, HLP_PORT);
+  cmd_info["EPRT"] = command_info(1, &Commands::port, COM_EPRT, HLP_EPRT);
+  cmd_info["PASV"] = command_info(0, &Commands::pasv, COM_PASV, HLP_PASV);
+  cmd_info["EPSV"] = command_info(-1, &Commands::pasv, COM_EPSV, HLP_EPSV);
+  cmd_info["PWD"] = command_info(0, &Commands::sim1, COM_PWD, HLP_PWD);
+  cmd_info["CWD"] = command_info(-2, &Commands::cwd,  COM_CWD, HLP_CWD);
+  cmd_info["CDUP"] = command_info(0, &Commands::cwd,  COM_CDUP, HLP_CDUP);
+  cmd_info["MKD"] = command_info(-2, &Commands::mkd, 0, HLP_MKD);
+  cmd_info["RMD"] = command_info(-2, &Commands::rmd, 0, HLP_RMD);
+  cmd_info["DELE"] = command_info(-2, &Commands::dele, 0, HLP_DELE);
+  cmd_info["LIST"] = command_info(-1, &Commands::list, COM_LONG, HLP_LIST);
+  cmd_info["NLST"] = command_info(-1, &Commands::list, COM_SHORT, HLP_NLST);
+  cmd_info["TYPE"] = command_info(-2, &Commands::sim1, COM_TYPE, HLP_TYPE);
+  cmd_info["MODE"] = command_info(1, &Commands::sim1, COM_MODE, HLP_MODE);
+  cmd_info["STRU"] = command_info(1, &Commands::sim1, COM_STRU, HLP_STRU);
+  cmd_info["SIZE"] = command_info(-2, &Commands::sim2, COM_SIZE, HLP_SIZE);
+  cmd_info["USER"] = command_info(1, &Commands::user, BEFORE_USER, HLP_USER);
+  cmd_info["PASS"] = command_info(-2, &Commands::pass, BEFORE_USER, HLP_PASS);
+  cmd_info["QUIT"] = command_info(-1, &Commands::quit, BEFORE_USER, HLP_QUIT);
+  cmd_info["NOOP"] = command_info(0, &Commands::sim1, COM_NOOP, HLP_NOOP);
+  cmd_info["MDTM"] = command_info(-2, &Commands::sim2, COM_MDTM, HLP_MDTM);
+  cmd_info["FEAT"] =
+    command_info(0, &Commands::sim1, COM_FEAT | BEFORE_USER, HLP_FEAT);
+  cmd_info["RNFR"] = command_info(-2, &Commands::rname, COM_FROM, HLP_RNFR);
+  cmd_info["RNTO"] = command_info(-2, &Commands::rname, COM_TO, HLP_RNTO);
+  cmd_info["MLST"] = command_info(-2, &Commands::sim2, COM_MLST, HLP_MLST);
+  cmd_info["MLSD"] = command_info(-1, &Commands::list, COM_MLSD, HLP_MLSD);
+  cmd_info["APPE"] = command_info(-2, &Commands::stor, COM_APPE, HLP_APPE);
+  cmd_info["OPTS"] = command_info(-1, &Commands::opts, 0, HLP_OPTS);
+  cmd_info["REST"] = command_info(1, &Commands::rest, 0, HLP_REST);
+  // the X*** commands are required by rfc1123.
+  cmd_info["XCWD"] = command_info(-2, &Commands::cwd, COM_CWD, HLP_CWD);
+  cmd_info["XPWD"] = command_info(0, &Commands::sim1, COM_PWD, HLP_PWD);
+  cmd_info["XCUP"] = command_info(0, &Commands::sim1, COM_CDUP, HLP_CDUP);
+  cmd_info["XMKD"] = command_info(-2, &Commands::mkd, 0, HLP_MKD);
+  cmd_info["XRMD"] = command_info(-2, &Commands::rmd, 0, HLP_RMD);
 #ifdef USE_TLS
-  { "AUTH",  1, &Commands::auth, BEFORE_USER, HLP_AUTH },
-  { "PBSZ",  1, &Commands::sim1, COM_PBSZ | BEFORE_USER, HLP_PBSZ },
-  { "PROT",  1, &Commands::sim1, COM_PROT | BEFORE_USER, HLP_PROT }, //40
-  { "CCC",   0, &Commands::sim1, COM_CCC,   HLP_CCC  },
+  cmd_info["AUTH"] = command_info(1, &Commands::auth, BEFORE_USER, HLP_AUTH);
+  cmd_info["PBSZ"] =
+    command_info(1, &Commands::sim1, COM_PBSZ | BEFORE_USER, HLP_PBSZ);
+  cmd_info["PROT"] =
+    command_info(1, &Commands::sim1, COM_PROT | BEFORE_USER, HLP_PROT);
+  cmd_info["CCC"] = command_info(0, &Commands::sim1, COM_CCC, HLP_CCC);
   // these commands are required to be understood by rfc2228, even if
   // we don't use them.
-  { "CONF", -1, &Commands::sim1, COM_CONF | BEFORE_USER, "" },
-  { "MIC",  -1, &Commands::sim1, COM_MIC | BEFORE_USER, "" },
-  { "ENC",  -1, &Commands::sim1, COM_ENC | BEFORE_USER, "" },
+  cmd_info["CONF"] =
+    command_info(-1, &Commands::sim1, COM_CONF | BEFORE_USER, "");
+  cmd_info["MIC"] =
+    command_info(-1, &Commands::sim1, COM_MIC | BEFORE_USER, "");
+  cmd_info["ENC"] =
+    command_info(-1, &Commands::sim1, COM_ENC | BEFORE_USER, "");
 #endif // USE_TLS
-  // An empty hlp field means no help will be displayed about the 
-  // object, what is noteworthy is that those entries must come last 
-  // as to not screwup the format when we display the help list.
-  { "ABOR",  0, &Commands::abor, 0,         ""       },
-  { "\n",    0, NULL           , LAST_COM,  ""       } // this goes last.
-};
+  // An empty hlp field means no help will be displayed about the command
+  cmd_info["ABOR"] = command_info(0, &Commands::abor, 0, HLP_ABOR);
+}
+
+Handler::~Handler()
+{
+  cmd_info.clear();
+}
 
 class User *Handler::initializer(int socket_id)
 {
@@ -76,7 +91,7 @@ class User *Handler::initializer(int soc
   socklen_t len = sizeof(sockaddr_in);
   
   getpeername(socket_id, reinterpret_cast<struct sockaddr*>(&addr), &len);
-  class User *user = new User(socket_id, addr); // initiating the user object, with initial stuff
+  class User *user = new User(socket_id, addr);
 
   string log = "new connection from: ";
   log += inet_ntoa(addr.sin_addr);
@@ -90,17 +105,16 @@ class User *Handler::initializer(int soc
   if(static_cast<int>(user_list.size()) > config->general.connection_limit)
   {
     // reached maximum number of connections...
-    message = "421 Maximum number of connections reached, please try again later.";
-    sem_wait(&user->user_lock);
-    user->logged_in = LOGGED_OUT;
-    sem_post(&user->user_lock);
+    message =
+      "421 Maximum number of connections reached, please try again later.";
+    user->settings(FAILURE, B_SET);
   }
   else
   {
     // dns lookup should go here.. find a nice way of doing it.
     message = "220 " + config->general.welcome_msg;
   }
-  comm.ftp_send(user, message);
+  *user << message << "\r\n";
 
   return(user);
 }
@@ -110,10 +124,12 @@ bool Handler::init(User *user)
   while(true)
   {
     string command;
-    if(user->logged_in == LOGGED_OUT)
+    if(user->settings(FAILURE))
       break;
-    if(comm.ftp_receive(user, command))
-      Handler::interpreter(user, command);
+    *user >> command;
+    util.clean_string(command);
+    if(!command.empty())
+      this->interpreter(user, command);
   }
   return(true); // we're returning to wrapper for exit.
 }
@@ -121,59 +137,58 @@ bool Handler::init(User *user)
 bool Handler::interpreter(User *user, string command)
 {
   string argument, message;
-  int cmd = 0;
   class StringTokenizer *st = NULL;
 
-  int words = util.clean_string(command);
-
-  if(words > 0)
-  {
-    st = new StringTokenizer(command, " ", true);
+  st = new StringTokenizer(command, " ", false);
+  int words = st->countTokens() - 1;
     command = st->nextToken();
-  }
 
-  transform(command.begin(), command.end(), command.begin(), (int(*)(int))toupper);
-  if(st)
-  {
+  transform(command.begin(), command.end(), command.begin(),
+      (int(*)(int))toupper);
+
     if(command == "SITE")
     {
       st->nextToken();
       command += " " + st->nextToken();
-      transform(command.begin() + 4, command.end(), command.begin() + 4, (int(*)(int))toupper);
+    transform(command.begin() + 4, command.end(), command.begin() + 4,
+        (int(*)(int))toupper);
+    words--;
     }
     argument = st->restTokens();
     delete(st);
-  }
 
   if(command != "PASS")
     logging->log_this(5, TYPE_DEBUG, command + "-" + argument);
   else
     logging->log_this(5, TYPE_DEBUG, "PASS-**********");
 
-  for(; cmd_info[cmd].extra_flag != LAST_COM; cmd++)
-    if(cmd_info[cmd].command == command)
-      break;
+  hash_map<const char*, struct command_info, hash<const char*>,
+    Utilities::eqstr>::iterator cmd_it = cmd_info.find(command.c_str());
     
-  if(cmd_info[cmd].extra_flag == LAST_COM)
+  if(cmd_it == cmd_info.end())
     message = "500 '" + command + "' not understood.";
   else
   {
-    if(user->logged_in < LOGGED_IN && !util.is_set(cmd_info[cmd].extra_flag, BEFORE_USER))
+    if(user->logged_in() < LOGGED_IN &&
+        !util.is_set((*(cmd_it)).second.extra_flag,BEFORE_USER))
       message = "530 Login with 'USER' and 'PASS' first.";
     else
     {
-      if((user->temp_buf.size() > 0) && command != "RNTO")
-        user->temp_buf.erase(); // we don't want this hanging around forever.
+      if((!user->temp_buf().empty()) && command != "RNTO")
+        user->temp_buf(""); // we don't want this hanging around forever.
 
-      if(words == 0 && words < cmd_info[cmd].ant_arg)
+      if(words == 0 && (((*(cmd_it)).second.ant_arg == -2) ||
+            (words < (*(cmd_it)).second.ant_arg)))
         message = "501 '" + command + "': requires an argument.";
-      else if(cmd_info[cmd].ant_arg != -1 && words > cmd_info[cmd].ant_arg)
+      else if((*(cmd_it)).second.ant_arg >= 0 &&
+          words > (*(cmd_it)).second.ant_arg)
         message = "501 '" + command + "': to many arguments to command.";
       else
-        ((comm.*cmd_info[cmd].pf) (user, argument, cmd_info[cmd].extra_flag));
+        ((comm.*(*(cmd_it)).second.pf)
+         (user, argument, (*(cmd_it)).second.extra_flag));
     }
   }
-  if(message.size() > 0)
-    comm.ftp_send(user, message);
+  if(!message.empty())
+    *user << message << "\r\n";
   return(true);
 }
Index: Handler.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Handler.h,v
retrieving revision 1.47
diff -u -p -b -r1.47 Handler.h
--- Handler.h	8 Jan 2005 16:22:02 -0000	1.47
+++ Handler.h	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: Handler.h,v 1.47 2005/01/08 16:22:02 klas Exp $
+// $Id: Handler.h,v 1.51 2005/03/27 23:50:18 jockelundin Exp $
 //
 // Usage: the main loop for connected clients and interpreter for
 //        ftp commands.
@@ -8,25 +8,37 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __HANDLER_H__
-#define __HANDLER_H__
+#ifndef HANDLER_H
+#define HANDLER_H
 
-#ifdef __HANDLER_CPP__
+#ifdef HANDLER_CPP
 #include "generic.h"
+#include "Utilities.h"
+#include "Configuration.h"
+#include "Log.h"
+#include "Connection.h"
 #include "Commands.h"
 #include "User.h"
-#include "Configuration.h"
-#include "Utilities.h"
 #include "StringTokenizer.h"
-#include "Log.h"
 #endif
 
 struct command_info {
-  const string command; //the command name
-  const int ant_arg; //Number of arguments. -1 means variable size.
-  bool (Commands::*pf)(User*, string, unsigned int); //the function we will call
-  const unsigned int extra_flag; //extra flags that is needed by that function
-  const string hlp_info; //the help field, if this is empty no help will be displayed
+  int ant_arg; //Number of arguments. -1 means variable size.
+  bool (Commands::*pf)(User*, string, unsigned int);
+  unsigned int extra_flag; //extra flags that is needed by that function
+  string hlp_info; // if this is empty, no help.
+  // constructor for assigning the hash
+  command_info(int a,
+      bool (Commands::*p)(User*, string, unsigned int),
+      unsigned int e, string h)
+  {
+    ant_arg = a;
+    pf = p;
+    extra_flag = e;
+    hlp_info = h;
+  }
+  // and one to make the hash functions happy that it still looks like a struct
+  command_info() {};
 };
 
 class Handler
@@ -34,15 +46,16 @@ class Handler
   private:
     bool interpreter(User*, string);
   public:
+    Handler();
+    ~Handler();
     bool init(User*);
     class User *initializer(int);
-    static struct command_info cmd_info[];
+    hash_map<const char*, struct command_info, hash<const char*>,
+      Utilities::eqstr> cmd_info;
 };
 
-extern class Commands comm;
-extern class Configuration *config;
-extern bool term;
-extern bool hup;
+extern class Handler *handler;
+
 extern vector<User*> user_list;
 extern sem_t user_list_lock;
 
